#include <STC8G.H>
#include "define.h"
#include <intrins.h>
#define 	RXD		P30
#define 	TXD		P31
#define 	SCL		P32
#define 	SDA		P33

bit I2C_Busy;

unsigned char code BMP[]=
{
	#include <0.h>
};

void Delay_10ms(void)
{
	unsigned char i,j;
	_nop_();
	_nop_();
	i=144;
	j=157;
	do
	{
		while(--j);
	}
	while(--i);
	WDT_CONTR=CLR_WDT;
}

void Delay_x10ms(unsigned char x)
{
	while(--x)
		Delay_10ms();
}

void I2C_Start(void)
{
	I2C_Busy=1;
	I2CMSCR=0x81;
	while(I2C_Busy);
}

void I2C_SendData(unsigned char dat)
{
	I2CTXD=dat;
	I2C_Busy=1;
	I2CMSCR=0x82;
	while(I2C_Busy);
}

void I2C_RecvACK(void)
{
	I2C_Busy=1;
	I2CMSCR=0x83;
	while(I2C_Busy);
}

//unsigned char I2C_RecvData(void)
//{
//	I2C_Busy=1;
//	I2CMSCR=0x84;
//	while(I2C_Busy);
//	return I2CRXD;
//}

//void I2C_SendACK(void)
//{
//	I2CMSST=0x00;
//	I2C_Busy=1;
//	I2CMSCR=0x85;
//	while(I2C_Busy);
//}

//void I2C_SendNAK(void)
//{
//	I2CMSST=0x01;
//	I2C_Busy=1;
//	I2CMSCR=0x85;
//	while(I2C_Busy);
//}

void I2C_Stop(void)
{
	I2C_Busy=1;
	I2CMSCR=0x86;
	while(I2C_Busy);
}

void SSD1316_Write_CMD(unsigned char cmd)
{
	I2C_Start();
	I2C_SendData(0x78);
	I2C_RecvACK();
	I2C_SendData(0x00);
	I2C_RecvACK();
	I2C_SendData(cmd);
	I2C_RecvACK();
	I2C_Stop();
}

void SSD1316_Write_DATA_A(void)
{
	I2C_Start();
	I2C_SendData(0x78);
	I2C_RecvACK();
	I2C_SendData(0x40);
	I2C_RecvACK();
}

void SSD1316_Write_DATA_B(unsigned char dat)
{
	I2C_SendData(dat);
	I2C_RecvACK();
}

void SSD1316_Write_DATA_C(void)
{
	I2C_Stop();
}

void SSD1316_Clear(void)  
{  
	unsigned char i,n;		    
	for(i=0;i<4;i++)  
	{  
		SSD1316_Write_CMD(0xb0+i);	//ҳַ0~3
		SSD1316_Write_CMD(0x00);	//ʾλáе͵ַ
		SSD1316_Write_CMD(0x10);	//ʾλáиߵַ  
		SSD1316_Write_DATA_A();		
		for(n=0;n<128;n++)
		{
			SSD1316_Write_DATA_B(0x00);
		}
		SSD1316_Write_DATA_C();
	}
}

void SSD1316_Display_128x32(void)
{
	unsigned int i;
	SSD1316_Write_CMD(0x20);	//Set Memory Addressing ModeڴѰַģʽ
	SSD1316_Write_CMD(0x01);	//0x01ֱѰַģʽ
	SSD1316_Write_CMD(0x21);	//Set Column Addressеַ
	SSD1316_Write_CMD(0);		//пʼַ
	SSD1316_Write_CMD(127);		//нַ
	SSD1316_Write_CMD(0x22);	//Set Page Addressҳַ
	SSD1316_Write_CMD(0x00);	//0
	SSD1316_Write_CMD(0x03);	//3
	SSD1316_Write_DATA_A();
	for(i=0;i<512;i++)
	{
		SSD1316_Write_DATA_B(BMP[i]);
	}
	SSD1316_Write_DATA_C();
	SSD1316_Write_CMD(0x20);	//Set Memory Addressing ModeڴѰַģʽ
	SSD1316_Write_CMD(0x02);	//0x02ҳѰַģʽ
}

void SSD1316_Init(void)
{
	SSD1316_Write_CMD(0xAE);	//Set Display OFFʾأ
	SSD1316_Write_CMD(0xA1);	//Set Segment Remapӳ䣩
	SSD1316_Write_CMD(0xA8);	//Set Multiplex Ratioͨ
	SSD1316_Write_CMD(0x1F);	//31
//	SSD1316_Write_CMD(0xC8);	//Set COM Output Scan Directionӳ䣩
	SSD1316_Write_CMD(0xD3);	//Set Display Offsetôֱƫ
	SSD1316_Write_CMD(0x00);	//0
	SSD1316_Write_CMD(0xD5);	//Set Display Clock Divide Ratio/Oscillator FrequencyʾʱӷƵƵʣ
	SSD1316_Write_CMD(0xF0);	//0xF0
	SSD1316_Write_CMD(0x8D);	//Charge Pump Settingõɱã
	SSD1316_Write_CMD(0x14);	//0x14
	SSD1316_Write_CMD(0xAF);	//Set Display ONʾ
	SSD1316_Clear();
//	SSD1316_Write_CMD(0x81);	//Set Contrast ControlöԱȶȣ
//	SSD1316_Write_CMD(0x7F);	//127
//	SSD1316_Write_CMD(0xA7);	//Set Normal/Inverse Display÷ʾ
}

void Init(void)
{
	P_SW2|=EAXFR;
	P3M0=0x00;
	P3M1=0x00;
	P5M0=0x00;
	P5M1=0x00;
	P3PU=0x0c;
	I2CCFG=0xC1;	//921.6K@11.0592M
	I2CMSCR=EMSI;
	I2CMSST=0x00;
	EA=1;
	Delay_x10ms(10);
	SSD1316_Init();
}

void main(void)
{
	Init();
	SSD1316_Display_128x32();
	while(1)
	{
		SSD1316_Write_CMD(0xA6);
		Delay_x10ms(50);
		SSD1316_Write_CMD(0xA7);
		Delay_x10ms(50);
	}
}

void I2C_Isr(void) interrupt 24
{
	_push_(P_SW2);
	P_SW2|=EAXFR;
	if(I2CMSST&MSIF)
	{
		I2CMSST&=~MSIF;
		I2C_Busy=0;
	}
	_pop_(P_SW2);
}